/*
 * Akeyless API
 *
 * The purpose of this application is to provide access to Akeyless API.
 *
 * API version: 2.0
 * Contact: support@akeyless.io
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package akeyless

import (
	"encoding/json"
)

// GetAccountSettingsCommandOutput struct for GetAccountSettingsCommandOutput
type GetAccountSettingsCommandOutput struct {
	AccountId *string `json:"account_id,omitempty"`
	Address *CustomerFullAddress `json:"address,omitempty"`
	CompanyName *string `json:"company_name,omitempty"`
	Email *string `json:"email,omitempty"`
	GeneralSettings *AccountGeneralSettings `json:"general_settings,omitempty"`
	ObjectVersionSettings *AccountObjectVersionSettingsOutput `json:"object_version_settings,omitempty"`
	Phone *string `json:"phone,omitempty"`
	SecretManagement *SmInfo `json:"secret_management,omitempty"`
	SecureRemoteAccess *SraInfo `json:"secure_remote_access,omitempty"`
	SystemAccessCredsSettings *SystemAccessCredsSettings `json:"system_access_creds_settings,omitempty"`
}

// NewGetAccountSettingsCommandOutput instantiates a new GetAccountSettingsCommandOutput object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGetAccountSettingsCommandOutput() *GetAccountSettingsCommandOutput {
	this := GetAccountSettingsCommandOutput{}
	return &this
}

// NewGetAccountSettingsCommandOutputWithDefaults instantiates a new GetAccountSettingsCommandOutput object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGetAccountSettingsCommandOutputWithDefaults() *GetAccountSettingsCommandOutput {
	this := GetAccountSettingsCommandOutput{}
	return &this
}

// GetAccountId returns the AccountId field value if set, zero value otherwise.
func (o *GetAccountSettingsCommandOutput) GetAccountId() string {
	if o == nil || o.AccountId == nil {
		var ret string
		return ret
	}
	return *o.AccountId
}

// GetAccountIdOk returns a tuple with the AccountId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetAccountSettingsCommandOutput) GetAccountIdOk() (*string, bool) {
	if o == nil || o.AccountId == nil {
		return nil, false
	}
	return o.AccountId, true
}

// HasAccountId returns a boolean if a field has been set.
func (o *GetAccountSettingsCommandOutput) HasAccountId() bool {
	if o != nil && o.AccountId != nil {
		return true
	}

	return false
}

// SetAccountId gets a reference to the given string and assigns it to the AccountId field.
func (o *GetAccountSettingsCommandOutput) SetAccountId(v string) {
	o.AccountId = &v
}

// GetAddress returns the Address field value if set, zero value otherwise.
func (o *GetAccountSettingsCommandOutput) GetAddress() CustomerFullAddress {
	if o == nil || o.Address == nil {
		var ret CustomerFullAddress
		return ret
	}
	return *o.Address
}

// GetAddressOk returns a tuple with the Address field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetAccountSettingsCommandOutput) GetAddressOk() (*CustomerFullAddress, bool) {
	if o == nil || o.Address == nil {
		return nil, false
	}
	return o.Address, true
}

// HasAddress returns a boolean if a field has been set.
func (o *GetAccountSettingsCommandOutput) HasAddress() bool {
	if o != nil && o.Address != nil {
		return true
	}

	return false
}

// SetAddress gets a reference to the given CustomerFullAddress and assigns it to the Address field.
func (o *GetAccountSettingsCommandOutput) SetAddress(v CustomerFullAddress) {
	o.Address = &v
}

// GetCompanyName returns the CompanyName field value if set, zero value otherwise.
func (o *GetAccountSettingsCommandOutput) GetCompanyName() string {
	if o == nil || o.CompanyName == nil {
		var ret string
		return ret
	}
	return *o.CompanyName
}

// GetCompanyNameOk returns a tuple with the CompanyName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetAccountSettingsCommandOutput) GetCompanyNameOk() (*string, bool) {
	if o == nil || o.CompanyName == nil {
		return nil, false
	}
	return o.CompanyName, true
}

// HasCompanyName returns a boolean if a field has been set.
func (o *GetAccountSettingsCommandOutput) HasCompanyName() bool {
	if o != nil && o.CompanyName != nil {
		return true
	}

	return false
}

// SetCompanyName gets a reference to the given string and assigns it to the CompanyName field.
func (o *GetAccountSettingsCommandOutput) SetCompanyName(v string) {
	o.CompanyName = &v
}

// GetEmail returns the Email field value if set, zero value otherwise.
func (o *GetAccountSettingsCommandOutput) GetEmail() string {
	if o == nil || o.Email == nil {
		var ret string
		return ret
	}
	return *o.Email
}

// GetEmailOk returns a tuple with the Email field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetAccountSettingsCommandOutput) GetEmailOk() (*string, bool) {
	if o == nil || o.Email == nil {
		return nil, false
	}
	return o.Email, true
}

// HasEmail returns a boolean if a field has been set.
func (o *GetAccountSettingsCommandOutput) HasEmail() bool {
	if o != nil && o.Email != nil {
		return true
	}

	return false
}

// SetEmail gets a reference to the given string and assigns it to the Email field.
func (o *GetAccountSettingsCommandOutput) SetEmail(v string) {
	o.Email = &v
}

// GetGeneralSettings returns the GeneralSettings field value if set, zero value otherwise.
func (o *GetAccountSettingsCommandOutput) GetGeneralSettings() AccountGeneralSettings {
	if o == nil || o.GeneralSettings == nil {
		var ret AccountGeneralSettings
		return ret
	}
	return *o.GeneralSettings
}

// GetGeneralSettingsOk returns a tuple with the GeneralSettings field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetAccountSettingsCommandOutput) GetGeneralSettingsOk() (*AccountGeneralSettings, bool) {
	if o == nil || o.GeneralSettings == nil {
		return nil, false
	}
	return o.GeneralSettings, true
}

// HasGeneralSettings returns a boolean if a field has been set.
func (o *GetAccountSettingsCommandOutput) HasGeneralSettings() bool {
	if o != nil && o.GeneralSettings != nil {
		return true
	}

	return false
}

// SetGeneralSettings gets a reference to the given AccountGeneralSettings and assigns it to the GeneralSettings field.
func (o *GetAccountSettingsCommandOutput) SetGeneralSettings(v AccountGeneralSettings) {
	o.GeneralSettings = &v
}

// GetObjectVersionSettings returns the ObjectVersionSettings field value if set, zero value otherwise.
func (o *GetAccountSettingsCommandOutput) GetObjectVersionSettings() AccountObjectVersionSettingsOutput {
	if o == nil || o.ObjectVersionSettings == nil {
		var ret AccountObjectVersionSettingsOutput
		return ret
	}
	return *o.ObjectVersionSettings
}

// GetObjectVersionSettingsOk returns a tuple with the ObjectVersionSettings field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetAccountSettingsCommandOutput) GetObjectVersionSettingsOk() (*AccountObjectVersionSettingsOutput, bool) {
	if o == nil || o.ObjectVersionSettings == nil {
		return nil, false
	}
	return o.ObjectVersionSettings, true
}

// HasObjectVersionSettings returns a boolean if a field has been set.
func (o *GetAccountSettingsCommandOutput) HasObjectVersionSettings() bool {
	if o != nil && o.ObjectVersionSettings != nil {
		return true
	}

	return false
}

// SetObjectVersionSettings gets a reference to the given AccountObjectVersionSettingsOutput and assigns it to the ObjectVersionSettings field.
func (o *GetAccountSettingsCommandOutput) SetObjectVersionSettings(v AccountObjectVersionSettingsOutput) {
	o.ObjectVersionSettings = &v
}

// GetPhone returns the Phone field value if set, zero value otherwise.
func (o *GetAccountSettingsCommandOutput) GetPhone() string {
	if o == nil || o.Phone == nil {
		var ret string
		return ret
	}
	return *o.Phone
}

// GetPhoneOk returns a tuple with the Phone field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetAccountSettingsCommandOutput) GetPhoneOk() (*string, bool) {
	if o == nil || o.Phone == nil {
		return nil, false
	}
	return o.Phone, true
}

// HasPhone returns a boolean if a field has been set.
func (o *GetAccountSettingsCommandOutput) HasPhone() bool {
	if o != nil && o.Phone != nil {
		return true
	}

	return false
}

// SetPhone gets a reference to the given string and assigns it to the Phone field.
func (o *GetAccountSettingsCommandOutput) SetPhone(v string) {
	o.Phone = &v
}

// GetSecretManagement returns the SecretManagement field value if set, zero value otherwise.
func (o *GetAccountSettingsCommandOutput) GetSecretManagement() SmInfo {
	if o == nil || o.SecretManagement == nil {
		var ret SmInfo
		return ret
	}
	return *o.SecretManagement
}

// GetSecretManagementOk returns a tuple with the SecretManagement field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetAccountSettingsCommandOutput) GetSecretManagementOk() (*SmInfo, bool) {
	if o == nil || o.SecretManagement == nil {
		return nil, false
	}
	return o.SecretManagement, true
}

// HasSecretManagement returns a boolean if a field has been set.
func (o *GetAccountSettingsCommandOutput) HasSecretManagement() bool {
	if o != nil && o.SecretManagement != nil {
		return true
	}

	return false
}

// SetSecretManagement gets a reference to the given SmInfo and assigns it to the SecretManagement field.
func (o *GetAccountSettingsCommandOutput) SetSecretManagement(v SmInfo) {
	o.SecretManagement = &v
}

// GetSecureRemoteAccess returns the SecureRemoteAccess field value if set, zero value otherwise.
func (o *GetAccountSettingsCommandOutput) GetSecureRemoteAccess() SraInfo {
	if o == nil || o.SecureRemoteAccess == nil {
		var ret SraInfo
		return ret
	}
	return *o.SecureRemoteAccess
}

// GetSecureRemoteAccessOk returns a tuple with the SecureRemoteAccess field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetAccountSettingsCommandOutput) GetSecureRemoteAccessOk() (*SraInfo, bool) {
	if o == nil || o.SecureRemoteAccess == nil {
		return nil, false
	}
	return o.SecureRemoteAccess, true
}

// HasSecureRemoteAccess returns a boolean if a field has been set.
func (o *GetAccountSettingsCommandOutput) HasSecureRemoteAccess() bool {
	if o != nil && o.SecureRemoteAccess != nil {
		return true
	}

	return false
}

// SetSecureRemoteAccess gets a reference to the given SraInfo and assigns it to the SecureRemoteAccess field.
func (o *GetAccountSettingsCommandOutput) SetSecureRemoteAccess(v SraInfo) {
	o.SecureRemoteAccess = &v
}

// GetSystemAccessCredsSettings returns the SystemAccessCredsSettings field value if set, zero value otherwise.
func (o *GetAccountSettingsCommandOutput) GetSystemAccessCredsSettings() SystemAccessCredsSettings {
	if o == nil || o.SystemAccessCredsSettings == nil {
		var ret SystemAccessCredsSettings
		return ret
	}
	return *o.SystemAccessCredsSettings
}

// GetSystemAccessCredsSettingsOk returns a tuple with the SystemAccessCredsSettings field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetAccountSettingsCommandOutput) GetSystemAccessCredsSettingsOk() (*SystemAccessCredsSettings, bool) {
	if o == nil || o.SystemAccessCredsSettings == nil {
		return nil, false
	}
	return o.SystemAccessCredsSettings, true
}

// HasSystemAccessCredsSettings returns a boolean if a field has been set.
func (o *GetAccountSettingsCommandOutput) HasSystemAccessCredsSettings() bool {
	if o != nil && o.SystemAccessCredsSettings != nil {
		return true
	}

	return false
}

// SetSystemAccessCredsSettings gets a reference to the given SystemAccessCredsSettings and assigns it to the SystemAccessCredsSettings field.
func (o *GetAccountSettingsCommandOutput) SetSystemAccessCredsSettings(v SystemAccessCredsSettings) {
	o.SystemAccessCredsSettings = &v
}

func (o GetAccountSettingsCommandOutput) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.AccountId != nil {
		toSerialize["account_id"] = o.AccountId
	}
	if o.Address != nil {
		toSerialize["address"] = o.Address
	}
	if o.CompanyName != nil {
		toSerialize["company_name"] = o.CompanyName
	}
	if o.Email != nil {
		toSerialize["email"] = o.Email
	}
	if o.GeneralSettings != nil {
		toSerialize["general_settings"] = o.GeneralSettings
	}
	if o.ObjectVersionSettings != nil {
		toSerialize["object_version_settings"] = o.ObjectVersionSettings
	}
	if o.Phone != nil {
		toSerialize["phone"] = o.Phone
	}
	if o.SecretManagement != nil {
		toSerialize["secret_management"] = o.SecretManagement
	}
	if o.SecureRemoteAccess != nil {
		toSerialize["secure_remote_access"] = o.SecureRemoteAccess
	}
	if o.SystemAccessCredsSettings != nil {
		toSerialize["system_access_creds_settings"] = o.SystemAccessCredsSettings
	}
	return json.Marshal(toSerialize)
}

type NullableGetAccountSettingsCommandOutput struct {
	value *GetAccountSettingsCommandOutput
	isSet bool
}

func (v NullableGetAccountSettingsCommandOutput) Get() *GetAccountSettingsCommandOutput {
	return v.value
}

func (v *NullableGetAccountSettingsCommandOutput) Set(val *GetAccountSettingsCommandOutput) {
	v.value = val
	v.isSet = true
}

func (v NullableGetAccountSettingsCommandOutput) IsSet() bool {
	return v.isSet
}

func (v *NullableGetAccountSettingsCommandOutput) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGetAccountSettingsCommandOutput(val *GetAccountSettingsCommandOutput) *NullableGetAccountSettingsCommandOutput {
	return &NullableGetAccountSettingsCommandOutput{value: val, isSet: true}
}

func (v NullableGetAccountSettingsCommandOutput) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGetAccountSettingsCommandOutput) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


