/*
 * Akeyless API
 *
 * The purpose of this application is to provide access to Akeyless API.
 *
 * API version: 2.0
 * Contact: support@akeyless.io
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package akeyless

import (
	"encoding/json"
)

// MigrationItems struct for MigrationItems
type MigrationItems struct {
	Failed *int64 `json:"failed,omitempty"`
	Migrated *int64 `json:"migrated,omitempty"`
	Skipped *int64 `json:"skipped,omitempty"`
	Total *int64 `json:"total,omitempty"`
	Updated *int64 `json:"updated,omitempty"`
}

// NewMigrationItems instantiates a new MigrationItems object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMigrationItems() *MigrationItems {
	this := MigrationItems{}
	return &this
}

// NewMigrationItemsWithDefaults instantiates a new MigrationItems object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMigrationItemsWithDefaults() *MigrationItems {
	this := MigrationItems{}
	return &this
}

// GetFailed returns the Failed field value if set, zero value otherwise.
func (o *MigrationItems) GetFailed() int64 {
	if o == nil || o.Failed == nil {
		var ret int64
		return ret
	}
	return *o.Failed
}

// GetFailedOk returns a tuple with the Failed field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MigrationItems) GetFailedOk() (*int64, bool) {
	if o == nil || o.Failed == nil {
		return nil, false
	}
	return o.Failed, true
}

// HasFailed returns a boolean if a field has been set.
func (o *MigrationItems) HasFailed() bool {
	if o != nil && o.Failed != nil {
		return true
	}

	return false
}

// SetFailed gets a reference to the given int64 and assigns it to the Failed field.
func (o *MigrationItems) SetFailed(v int64) {
	o.Failed = &v
}

// GetMigrated returns the Migrated field value if set, zero value otherwise.
func (o *MigrationItems) GetMigrated() int64 {
	if o == nil || o.Migrated == nil {
		var ret int64
		return ret
	}
	return *o.Migrated
}

// GetMigratedOk returns a tuple with the Migrated field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MigrationItems) GetMigratedOk() (*int64, bool) {
	if o == nil || o.Migrated == nil {
		return nil, false
	}
	return o.Migrated, true
}

// HasMigrated returns a boolean if a field has been set.
func (o *MigrationItems) HasMigrated() bool {
	if o != nil && o.Migrated != nil {
		return true
	}

	return false
}

// SetMigrated gets a reference to the given int64 and assigns it to the Migrated field.
func (o *MigrationItems) SetMigrated(v int64) {
	o.Migrated = &v
}

// GetSkipped returns the Skipped field value if set, zero value otherwise.
func (o *MigrationItems) GetSkipped() int64 {
	if o == nil || o.Skipped == nil {
		var ret int64
		return ret
	}
	return *o.Skipped
}

// GetSkippedOk returns a tuple with the Skipped field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MigrationItems) GetSkippedOk() (*int64, bool) {
	if o == nil || o.Skipped == nil {
		return nil, false
	}
	return o.Skipped, true
}

// HasSkipped returns a boolean if a field has been set.
func (o *MigrationItems) HasSkipped() bool {
	if o != nil && o.Skipped != nil {
		return true
	}

	return false
}

// SetSkipped gets a reference to the given int64 and assigns it to the Skipped field.
func (o *MigrationItems) SetSkipped(v int64) {
	o.Skipped = &v
}

// GetTotal returns the Total field value if set, zero value otherwise.
func (o *MigrationItems) GetTotal() int64 {
	if o == nil || o.Total == nil {
		var ret int64
		return ret
	}
	return *o.Total
}

// GetTotalOk returns a tuple with the Total field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MigrationItems) GetTotalOk() (*int64, bool) {
	if o == nil || o.Total == nil {
		return nil, false
	}
	return o.Total, true
}

// HasTotal returns a boolean if a field has been set.
func (o *MigrationItems) HasTotal() bool {
	if o != nil && o.Total != nil {
		return true
	}

	return false
}

// SetTotal gets a reference to the given int64 and assigns it to the Total field.
func (o *MigrationItems) SetTotal(v int64) {
	o.Total = &v
}

// GetUpdated returns the Updated field value if set, zero value otherwise.
func (o *MigrationItems) GetUpdated() int64 {
	if o == nil || o.Updated == nil {
		var ret int64
		return ret
	}
	return *o.Updated
}

// GetUpdatedOk returns a tuple with the Updated field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MigrationItems) GetUpdatedOk() (*int64, bool) {
	if o == nil || o.Updated == nil {
		return nil, false
	}
	return o.Updated, true
}

// HasUpdated returns a boolean if a field has been set.
func (o *MigrationItems) HasUpdated() bool {
	if o != nil && o.Updated != nil {
		return true
	}

	return false
}

// SetUpdated gets a reference to the given int64 and assigns it to the Updated field.
func (o *MigrationItems) SetUpdated(v int64) {
	o.Updated = &v
}

func (o MigrationItems) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Failed != nil {
		toSerialize["failed"] = o.Failed
	}
	if o.Migrated != nil {
		toSerialize["migrated"] = o.Migrated
	}
	if o.Skipped != nil {
		toSerialize["skipped"] = o.Skipped
	}
	if o.Total != nil {
		toSerialize["total"] = o.Total
	}
	if o.Updated != nil {
		toSerialize["updated"] = o.Updated
	}
	return json.Marshal(toSerialize)
}

type NullableMigrationItems struct {
	value *MigrationItems
	isSet bool
}

func (v NullableMigrationItems) Get() *MigrationItems {
	return v.value
}

func (v *NullableMigrationItems) Set(val *MigrationItems) {
	v.value = val
	v.isSet = true
}

func (v NullableMigrationItems) IsSet() bool {
	return v.isSet
}

func (v *NullableMigrationItems) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMigrationItems(val *MigrationItems) *NullableMigrationItems {
	return &NullableMigrationItems{value: val, isSet: true}
}

func (v NullableMigrationItems) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMigrationItems) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


