/*
 * Akeyless API
 *
 * The purpose of this application is to provide access to Akeyless API.
 *
 * API version: 2.0
 * Contact: support@akeyless.io
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package akeyless

import (
	"encoding/json"
)

// OIDCCustomClaim OIDCCustomClaim is a custom claim specific to OIDC authentication method.
type OIDCCustomClaim struct {
	Name *string `json:"name,omitempty"`
	Values *[]string `json:"values,omitempty"`
}

// NewOIDCCustomClaim instantiates a new OIDCCustomClaim object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewOIDCCustomClaim() *OIDCCustomClaim {
	this := OIDCCustomClaim{}
	return &this
}

// NewOIDCCustomClaimWithDefaults instantiates a new OIDCCustomClaim object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewOIDCCustomClaimWithDefaults() *OIDCCustomClaim {
	this := OIDCCustomClaim{}
	return &this
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *OIDCCustomClaim) GetName() string {
	if o == nil || o.Name == nil {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OIDCCustomClaim) GetNameOk() (*string, bool) {
	if o == nil || o.Name == nil {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *OIDCCustomClaim) HasName() bool {
	if o != nil && o.Name != nil {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *OIDCCustomClaim) SetName(v string) {
	o.Name = &v
}

// GetValues returns the Values field value if set, zero value otherwise.
func (o *OIDCCustomClaim) GetValues() []string {
	if o == nil || o.Values == nil {
		var ret []string
		return ret
	}
	return *o.Values
}

// GetValuesOk returns a tuple with the Values field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OIDCCustomClaim) GetValuesOk() (*[]string, bool) {
	if o == nil || o.Values == nil {
		return nil, false
	}
	return o.Values, true
}

// HasValues returns a boolean if a field has been set.
func (o *OIDCCustomClaim) HasValues() bool {
	if o != nil && o.Values != nil {
		return true
	}

	return false
}

// SetValues gets a reference to the given []string and assigns it to the Values field.
func (o *OIDCCustomClaim) SetValues(v []string) {
	o.Values = &v
}

func (o OIDCCustomClaim) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Name != nil {
		toSerialize["name"] = o.Name
	}
	if o.Values != nil {
		toSerialize["values"] = o.Values
	}
	return json.Marshal(toSerialize)
}

type NullableOIDCCustomClaim struct {
	value *OIDCCustomClaim
	isSet bool
}

func (v NullableOIDCCustomClaim) Get() *OIDCCustomClaim {
	return v.value
}

func (v *NullableOIDCCustomClaim) Set(val *OIDCCustomClaim) {
	v.value = val
	v.isSet = true
}

func (v NullableOIDCCustomClaim) IsSet() bool {
	return v.isSet
}

func (v *NullableOIDCCustomClaim) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableOIDCCustomClaim(val *OIDCCustomClaim) *NullableOIDCCustomClaim {
	return &NullableOIDCCustomClaim{value: val, isSet: true}
}

func (v NullableOIDCCustomClaim) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableOIDCCustomClaim) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


